/*
 * Copyright (c) 2019-2020 Mellanox Technologies LTD. ALL RIGHTS RESERVED.
 * See file LICENSE for terms.
 */

#include "osm_calculate_port_groups_task.hpp"
#include "osm_parallel_port_groups_calculator.hpp"
#include "osm_armgr.hpp"
#include "osm_ar_algorithm.hpp"

void
OSMCalculatePortGroupsTreeTask::Run()
{
	m_port_groups_calculator_->GetAdaptiveRoutingManager()->
		ARCalculateSwitchPortGroupsTree(
			*m_sw_db_entry_,
			m_port_groups_calculator_->GetMaxRank(),
			m_port_groups_calculator_->GetHcaToSwLidMapping(),
			m_port_groups_calculator_->GetSwLidToRankMapping());

	m_port_groups_calculator_->OnTaskEnd();
}

void
OSMCalculatePortGroupsTask::Run()
{
	m_ar_algorithm_->CalculateSwitchPortGroups(
		*m_sw_db_entry_,
		m_port_groups_calculator_->GetLidMapping(),
		m_dst_sw_lid_to_conection_, /* temp data buffer used for calculation */
		m_base_lid_to_port_);       /* temp data buffer used for calculation */

	m_port_groups_calculator_->OnTaskEnd();
}
