/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         __cc_parser_parse
#define yylex           __cc_parser_lex
#define yyerror         __cc_parser_error
#define yydebug         __cc_parser_debug
#define yynerrs         __cc_parser_nerrs

#define yylval          __cc_parser_lval
#define yychar          __cc_parser_char

/* Copy the first part of user declarations.  */
#line 1 "./osm_cc_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2019 Mellanox Technologies LTD. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_CC_PARSER_Y_Y
#include <opensm/osm_opensm.h>

#define CC_MAX_MODE_LEN 1
#define NOT_DEFINED 0xff
#define YYSTYPE char*

typedef struct tmp_parser_struct_ {
	cl_list_t  str_list;
	cl_list_t  num_list;
} tmp_parser_struct_t;

extern FILE * __cc_parser_in;
static boolean_t in_profile;
static boolean_t in_sl_config;
static char *profile_min = NULL;
static char *profile_max = NULL;
static char *profile_percent = NULL;
static struct osm_opensm *p_osm;
cl_list_t num_list;
cl_list_t str_list;
char *__cc_parser_yylval = NULL;

tmp_parser_struct_t tmp_parser_struct;

int column_num;
int line_num;

osm_cc_profiles_conf_t *p_current_profiles_conf;
osm_cc_sl_conf_t *p_current_sl_conf;
osm_cc_vl_conf_t *p_current_vl_conf;
osm_cc_sw_conf_t *p_current_sw_conf;
osm_cc_ca_conf_t *p_current_ca_conf;
int current_profile_index = 0;

extern char *trim_whitespace(char *str);

static void clear_val(char **c)
{
	free(*c);
	*c = NULL;
}

static void yyerror(const char *format, ...)
{
    char s[256];
    va_list pvar;

    OSM_LOG_ENTER(&p_osm->log);

    va_start(pvar, format);
    vsnprintf(s, sizeof(s), format, pvar);
    va_end(pvar);

    OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR AC05: "
            "Syntax error (line %d:%d): %s\n",
            line_num, column_num, s);
    fprintf(stderr, "Error in CC Policy File (line %d:%d): %s.\n",
            line_num, column_num, s);
    OSM_LOG_EXIT(&p_osm->log);
}


/*void osm_destroy_profile_list(cl_qlist_t *p_list)
{
	cl_list_item_t *p_item;

	if (!p_list)
		return;

	p_item = cl_qlist_remove_head(p_list);
	while (p_item != cl_qlist_end(p_list)) {
		osm_destroy_cc_profile((osm_cc_profile_t *)p_item);
		p_item = cl_qlist_remove_head(p_list);
	}
}*/

static osm_cc_profiles_conf_t* create_profiles_conf()
{
	osm_cc_profiles_conf_t *p_profiles_conf = NULL;

	p_profiles_conf = calloc(1, sizeof(osm_cc_profiles_conf_t));
	if (!p_profiles_conf) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E06: "
			"Failed allocating memory for new profiles conf\n");
		goto Exit;
	}

	p_profiles_conf->mode = NOT_DEFINED;

	//cl_qlist_insert_tail(&p_osm->sm.cc_mgr.cc_profiles, &p_profiles_conf->list_item);
Exit:
	return p_profiles_conf;
}

static osm_cc_ca_conf_t* create_ca_conf()
{
	osm_cc_ca_conf_t *p_ca_conf = NULL;

	p_ca_conf = calloc(1, sizeof(osm_cc_ca_conf_t));
	if (!p_ca_conf) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E06: "
			"Failed allocating memory for new CA conf\n");
		goto Exit;
	}

	cl_qlist_insert_tail(&p_osm->sm.cc_mgr.ca_conf, &p_ca_conf->list_item);
Exit:
	return p_ca_conf;
}

static boolean_t create_sl_conf()
{
	boolean_t res = TRUE;

	p_current_sl_conf = calloc(1, sizeof(osm_cc_sl_conf_t));
	if (!p_current_sl_conf) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E06: "
			"Failed allocating memory for new SL profiles conf\n");
		res = FALSE;
		goto Exit;
	}

	cl_qlist_insert_tail(&p_osm->sm.cc_mgr.sl_profiles_conf, &p_current_sl_conf->list_item);
Exit:
	return res;
}

static boolean_t create_vl_conf()
{
	boolean_t res = TRUE;

	p_current_vl_conf = calloc(1, sizeof(osm_cc_vl_conf_t));
	if (!p_current_vl_conf) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E06: "
			"Failed allocating memory for new VL profiles conf\n");
		res = FALSE;
		goto Exit;
	}

	cl_qlist_insert_tail(&p_osm->sm.cc_mgr.vl_profiles_conf, &p_current_vl_conf->list_item);
Exit:
	return res;
}

static boolean_t create_sw_conf()
{
	boolean_t res = TRUE;

	p_current_sw_conf = calloc(1, sizeof(osm_cc_sw_conf_t));
	if (!p_current_sw_conf) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E06: "
			"Failed allocating memory for new SW conf\n");
		res = FALSE;
		goto Exit;
	}

	cl_qlist_insert_tail(&p_osm->sm.cc_mgr.sw_conf, &p_current_sw_conf->list_item);
Exit:
	return res;
}

static boolean_t create_profile()
{
	osm_cc_profile_t *p_profile;
	boolean_t res = TRUE;

	if (current_profile_index >= OSM_CC_MAX_PROFILE_NUM) {
		res = FALSE;
		goto Exit;
	}

	p_profile = &p_current_profiles_conf->profiles[current_profile_index];

// TODO: validate min, max, percent
	p_profile->min = atoi(profile_min);
	p_profile->max = atoi(profile_max);
	p_profile->percent = atoi(profile_percent);

	current_profile_index++;

Exit:
	return res;
}

static void clear_profile()
{
	clear_val(&profile_min);
	clear_val(&profile_max);
	clear_val(&profile_percent);
	clear_val(&__cc_parser_yylval);
}

boolean_t __cc_profile_is_tag_defined(const char *str, const char *tag_name)
{
	if (str) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E01: Profile %s "
			"qualifier already defined (%.200s), Aborting "
			"congestion control parsing!!!\n", tag_name, str);
		return TRUE;
	}

	return FALSE;
}

/*void __cc_parser_error(const char *str)
{
        OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "%.200s\n", str);
}*/

int __cc_parser_wrap()
{
        return 1;
}

int __cc_parser_parse();
int __cc_parser_lex();

int parse_congestion_control_policy(struct osm_opensm *osm_ptr)
{
	int res = 0;
	p_osm = osm_ptr;
	__cc_parser_in = NULL;
	cl_list_construct(&num_list);
	cl_list_init(&num_list, 10);
	cl_list_construct(&str_list);
	cl_list_init(&str_list, 10);
	current_profile_index = 0;
	line_num = 0;
	column_num = 0;

	if (!p_osm->subn.opt.congestion_control_policy_file) {
		OSM_LOG(&p_osm->log, OSM_LOG_DEBUG, "No policy file to parse -"
			" Quit cc parser\n");
		res = 1;
		goto Exit;
	}

	osm_cc_mgr_destroy(&p_osm->sm.cc_mgr);
	__cc_parser_in = fopen(p_osm->subn.opt.congestion_control_policy_file, "r");
	if (!__cc_parser_in) {
		__cc_parser_error("ERR 8E02: Congestion control policy file specified but not found\n");
		res = 1;
		goto Exit;
	}

        res =  __cc_parser_parse();
	if (res) {
		__cc_parser_error("ERR 8E04: Congestion control policy file parsing failed\n");
		osm_cc_mgr_destroy(&p_osm->sm.cc_mgr);
	} else {
		OSM_LOG(&p_osm->log, OSM_LOG_DEBUG, "Congestion control "
			"policy file parsed successfully\n");
	}

Exit:
	if (__cc_parser_in) {
		fclose(__cc_parser_in);
		__cc_parser_in = NULL;
	}
	clear_profile();
	return res;
}


#line 379 "./osm_cc_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "osm_cc_parser_y.h".  */
#ifndef YY__CC_PARSER_OSM_CC_PARSER_Y_H_INCLUDED
# define YY__CC_PARSER_OSM_CC_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int __cc_parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    COMMENT = 258,
    COMMA = 259,
    WORD = 260,
    GROUP = 261,
    EXNUMBER = 262,
    NUMBER = 263,
    NAME = 264,
    PROFILES_START = 265,
    PROFILES_END = 266,
    MODE = 267,
    PROFILE_START = 268,
    PROFILE_END = 269,
    PERCENT = 270,
    MIN = 271,
    MAX = 272,
    SL_CONFIG_START = 273,
    SL_CONFIG_END = 274,
    SL_PROFILES = 275,
    VL_CONFIG_START = 276,
    VL_CONFIG_END = 277,
    VL_PROFILES = 278,
    SWITCH_CONFIG_START = 279,
    SWITCH_CONFIG_END = 280,
    ENABLE = 281,
    AQS_WEIGHT = 282,
    AQS_TIME = 283,
    CA_CONFIG_START = 284,
    CA_CONFIG_END = 285,
    ENABLE_NOTIFY = 286,
    ENABLE_REACT = 287,
    ENABLE_CLAMP_TGT_RATE = 288,
    ENABLE_CLAMP_TGT_RATE_AFTER_TIME_INC = 289,
    RPG_TIME_RESET = 290,
    RPG_BYTE_RESET = 291,
    RPG_THRESHOLD = 292,
    RPG_MAX_RATE = 293,
    RPG_AI_RATE = 294,
    RPG_HAI_RATE = 295,
    RPG_GD = 296,
    RPG_MIN_DEC_FAC = 297,
    RPG_MIN_RATE = 298,
    RATE_TO_SET_ON_FIRST_CNP = 299,
    DCE_TCP_G = 300,
    DCE_TCP_RTT = 301,
    RATE_REDUCE_MONITOR_PERIOD = 302,
    INITIAL_ALPHA_VALUE = 303,
    RP_FLOW_DEFINITION_MODE = 304,
    NP_FLOW_DEFINITION_MODE = 305,
    MIN_TIME_BETWEEN_CNPS = 306,
    CNP_SL_MODE = 307,
    CNP_SL = 308
  };
#endif
/* Tokens.  */
#define COMMENT 258
#define COMMA 259
#define WORD 260
#define GROUP 261
#define EXNUMBER 262
#define NUMBER 263
#define NAME 264
#define PROFILES_START 265
#define PROFILES_END 266
#define MODE 267
#define PROFILE_START 268
#define PROFILE_END 269
#define PERCENT 270
#define MIN 271
#define MAX 272
#define SL_CONFIG_START 273
#define SL_CONFIG_END 274
#define SL_PROFILES 275
#define VL_CONFIG_START 276
#define VL_CONFIG_END 277
#define VL_PROFILES 278
#define SWITCH_CONFIG_START 279
#define SWITCH_CONFIG_END 280
#define ENABLE 281
#define AQS_WEIGHT 282
#define AQS_TIME 283
#define CA_CONFIG_START 284
#define CA_CONFIG_END 285
#define ENABLE_NOTIFY 286
#define ENABLE_REACT 287
#define ENABLE_CLAMP_TGT_RATE 288
#define ENABLE_CLAMP_TGT_RATE_AFTER_TIME_INC 289
#define RPG_TIME_RESET 290
#define RPG_BYTE_RESET 291
#define RPG_THRESHOLD 292
#define RPG_MAX_RATE 293
#define RPG_AI_RATE 294
#define RPG_HAI_RATE 295
#define RPG_GD 296
#define RPG_MIN_DEC_FAC 297
#define RPG_MIN_RATE 298
#define RATE_TO_SET_ON_FIRST_CNP 299
#define DCE_TCP_G 300
#define DCE_TCP_RTT 301
#define RATE_REDUCE_MONITOR_PERIOD 302
#define INITIAL_ALPHA_VALUE 303
#define RP_FLOW_DEFINITION_MODE 304
#define NP_FLOW_DEFINITION_MODE 305
#define MIN_TIME_BETWEEN_CNPS 306
#define CNP_SL_MODE 307
#define CNP_SL 308

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE __cc_parser_lval;

int __cc_parser_parse (void);

#endif /* !YY__CC_PARSER_OSM_CC_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 536 "./osm_cc_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   120

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  75
/* YYNRULES -- Number of rules.  */
#define YYNRULES  126
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  170

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   308

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   366,   366,   368,   369,   372,   374,   375,   376,   377,
     378,   379,   380,   384,   387,   388,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   416,
     423,   427,   431,   435,   439,   443,   447,   451,   455,   459,
     463,   467,   471,   475,   479,   483,   487,   491,   495,   499,
     503,   507,   511,   515,   518,   519,   522,   523,   524,   525,
     526,   529,   533,   536,   540,   544,   548,   552,   555,   556,
     559,   560,   561,   562,   566,   573,   580,   583,   584,   587,
     588,   589,   590,   593,   596,   601,   605,   606,   609,   610,
     611,   614,   618,   657,   660,   664,   667,   668,   671,   672,
     673,   676,   680,   723,   724,   727,   739,   740,   743,   755,
     761,   766,   780,   800,   807,   814,   821
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "COMMA", "WORD", "GROUP",
  "EXNUMBER", "NUMBER", "NAME", "PROFILES_START", "PROFILES_END", "MODE",
  "PROFILE_START", "PROFILE_END", "PERCENT", "MIN", "MAX",
  "SL_CONFIG_START", "SL_CONFIG_END", "SL_PROFILES", "VL_CONFIG_START",
  "VL_CONFIG_END", "VL_PROFILES", "SWITCH_CONFIG_START",
  "SWITCH_CONFIG_END", "ENABLE", "AQS_WEIGHT", "AQS_TIME",
  "CA_CONFIG_START", "CA_CONFIG_END", "ENABLE_NOTIFY", "ENABLE_REACT",
  "ENABLE_CLAMP_TGT_RATE", "ENABLE_CLAMP_TGT_RATE_AFTER_TIME_INC",
  "RPG_TIME_RESET", "RPG_BYTE_RESET", "RPG_THRESHOLD", "RPG_MAX_RATE",
  "RPG_AI_RATE", "RPG_HAI_RATE", "RPG_GD", "RPG_MIN_DEC_FAC",
  "RPG_MIN_RATE", "RATE_TO_SET_ON_FIRST_CNP", "DCE_TCP_G", "DCE_TCP_RTT",
  "RATE_REDUCE_MONITOR_PERIOD", "INITIAL_ALPHA_VALUE",
  "RP_FLOW_DEFINITION_MODE", "NP_FLOW_DEFINITION_MODE",
  "MIN_TIME_BETWEEN_CNPS", "CNP_SL_MODE", "CNP_SL", "$accept", "cc_policy",
  "configurations", "comment", "configuration", "ca_config",
  "ca_config_entries", "ca_config_entrie", "ca_config_start",
  "ca_config_end", "ca_config_group", "ca_config_enable_notify",
  "ca_config_enable_react", "ca_config_enable_clamp_tgt_rate",
  "ca_config_enable_clamp_tgt_rate_after_time_inc",
  "ca_config_rpg_time_reset", "ca_config_rpg_byte_reset",
  "ca_config_rpg_threshold", "ca_config_rpg_max_rate",
  "ca_config_rpg_ai_rate", "ca_config_rpg_hai_rate", "ca_config_rpg_gd",
  "ca_config_rpg_min_dec_fac", "ca_config_rpg_min_rate",
  "ca_config_rate_to_set_on_first_cnp", "ca_config_dce_tcp_g",
  "ca_config_dce_tcp_rtt", "ca_config_rate_reduce_monitor_period",
  "ca_config_initial_alpha_value", "ca_config_min_time_between_cnps",
  "ca_config_cnp_sl_mode", "ca_config_cnp_sl", "switch_config",
  "switch_config_entries", "switch_config_entrie", "switch_config_start",
  "switch_config_end", "switch_config_group", "switch_config_enable",
  "switch_config_aqs_weight", "switch_config_aqs_time", "profiles",
  "profiles_entries", "profiles_entrie", "profiles_start", "profiles_end",
  "profile", "profile_entries", "profile_entrie", "sl_config",
  "sl_config_start", "sl_config_end", "sl_config_entries",
  "sl_config_entrie", "sl_config_group", "sl_config_profile_nums",
  "vl_config", "vl_config_start", "vl_config_end", "vl_config_entries",
  "vl_config_entrie", "vl_config_group", "vl_config_profiles", "num_list",
  "number", "string_list", "string", "word", "profile_start",
  "profiles_name", "profiles_mode", "profile_percent", "profile_min",
  "profile_max", "profile_end", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308
};
# endif

#define YYPACT_NINF -148

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-148)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -148,    12,    53,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,     2,     3,    57,    56,     4,     9,
    -148,     5,     7,    10,    11,    13,    43,    44,    49,    59,
      64,    65,    70,    71,    72,    73,    75,    76,    77,    78,
      79,    80,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,    15,  -148,    81,
      82,    83,  -148,  -148,  -148,  -148,  -148,  -148,  -148,    60,
    -148,    84,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
      88,  -148,    86,  -148,  -148,  -148,  -148,  -148,    90,  -148,
      91,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,     8,  -148,  -148,    93,  -148,  -148,
    -148,    94,  -148,  -148,    92,    95,    96,  -148,  -148,  -148,
    -148,  -148,  -148,    86,    91,  -148,  -148,  -148,  -148,  -148
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,     5,   119,    84,    94,   104,    71,
      39,    12,     4,     7,    14,     8,    64,     6,    78,    10,
      96,     9,   106,    11,     0,     0,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,    15,    13,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,     0,    72,     0,
       0,     0,    70,    65,    63,    66,    67,    68,    69,     0,
      85,     0,   120,    83,    79,    77,    82,    87,    80,    81,
       0,    95,     0,   100,    93,    97,    98,    99,     0,   105,
       0,   110,   103,   107,   108,   109,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    73,    74,
      75,    76,   121,   122,     0,   101,   115,   102,   113,   111,
     118,   112,   116,   126,     0,     0,     0,    92,    88,    89,
      90,    91,    86,     0,     0,   123,   124,   125,   114,   117
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -148,  -148,  -148,   -24,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -147,  -148,  -103,  -148,  -148,  -148,
    -148,  -148,  -148,  -148,  -148
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    11,    12,    13,    24,    53,    14,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    15,    25,    83,    16,    84,    85,    86,    87,
      88,    17,    26,    94,    18,    95,    96,   144,   158,    19,
      20,   104,    27,   105,   106,   107,    21,    22,   112,    28,
     113,   114,   115,   147,   148,   151,   152,    23,    97,    98,
      99,   159,   160,   161,   162
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      52,    82,    93,   103,   111,     4,     4,     4,    29,    77,
     108,     4,     3,   117,   116,   118,   168,     0,   119,   120,
     138,   121,   153,   154,   155,   156,   109,   110,    78,    79,
      80,    81,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   122,   123,    49,    50,    51,     4,   124,     5,     4,
       4,   169,   100,     6,     0,   142,    89,   125,    90,    91,
      92,     7,   126,   127,     8,   101,   102,     9,   128,   129,
     130,   131,    10,   132,   133,   134,   135,   136,   137,   139,
     140,   141,   143,   145,   146,   149,   150,   163,   164,     0,
     165,     0,     0,   166,   167,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     157
};

static const yytype_int16 yycheck[] =
{
      24,    25,    26,    27,    28,     3,     3,     3,     6,     6,
       6,     3,     0,     8,     5,     8,   163,    -1,     8,     8,
       5,     8,    14,    15,    16,    17,    22,    23,    25,    26,
      27,    28,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,     8,     8,    51,    52,    53,     3,     8,     5,     3,
       3,   164,     6,    10,    -1,     5,     9,     8,    11,    12,
      13,    18,     8,     8,    21,    19,    20,    24,     8,     8,
       8,     8,    29,     8,     8,     8,     8,     8,     8,     8,
       8,     8,     8,     5,     8,     5,     5,     4,     4,    -1,
       8,    -1,    -1,     8,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    55,    56,     0,     3,     5,    10,    18,    21,    24,
      29,    57,    58,    59,    62,    86,    89,    95,    98,   103,
     104,   110,   111,   121,    60,    87,    96,   106,   113,     6,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    51,
      52,    53,    57,    61,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,     6,    25,    26,
      27,    28,    57,    88,    90,    91,    92,    93,    94,     9,
      11,    12,    13,    57,    97,    99,   100,   122,   123,   124,
       6,    19,    20,    57,   105,   107,   108,   109,     6,    22,
      23,    57,   112,   114,   115,   116,     5,     8,     8,     8,
       8,     8,     8,     8,     8,     8,     8,     8,     8,     8,
       8,     8,     8,     8,     8,     8,     8,     8,     5,     8,
       8,     8,     5,     8,   101,     5,     8,   117,   118,     5,
       5,   119,   120,    14,    15,    16,    17,    57,   102,   125,
     126,   127,   128,     4,     4,     8,     8,     8,   118,   120
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    54,    55,    56,    56,    57,    58,    58,    58,    58,
      58,    58,    58,    59,    60,    60,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    87,    88,    88,    88,    88,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    96,
      97,    97,    97,    97,    98,    99,   100,   101,   101,   102,
     102,   102,   102,   103,   104,   105,   106,   106,   107,   107,
     107,   108,   109,   110,   111,   112,   113,   113,   114,   114,
     114,   115,   116,   117,   117,   118,   119,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     3,     0,     2,
       1,     1,     1,     1,     1,     1,     3,     0,     2,     1,
       1,     1,     1,     3,     1,     1,     0,     2,     1,     1,
       1,     2,     2,     3,     1,     1,     0,     2,     1,     1,
       1,     2,     2,     1,     3,     1,     1,     3,     1,     1,
       1,     2,     2,     2,     2,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 372 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {}
#line 1770 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 39:
#line 416 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	free(p_current_ca_conf);
	p_current_ca_conf = create_ca_conf();
	if (!p_current_ca_conf)
		return 1;
}
#line 1781 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 40:
#line 423 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf = NULL;
}
#line 1789 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 41:
#line 427 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->group_type = osm_cc_get_group_type(__cc_parser_yylval);
}
#line 1797 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 42:
#line 431 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->enable_notify = atoi(__cc_parser_yylval);
}
#line 1805 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 43:
#line 435 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->enable_react = atoi(__cc_parser_yylval);
}
#line 1813 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 44:
#line 439 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.enable_clamp_tgt_rate = atoi(__cc_parser_yylval);
}
#line 1821 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 45:
#line 443 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.enable_clamp_tgt_rate_after_time_inc = atoi(__cc_parser_yylval);
}
#line 1829 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 46:
#line 447 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_time_reset = atoi(__cc_parser_yylval);
}
#line 1837 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 47:
#line 451 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_byte_reset = atoi(__cc_parser_yylval);
}
#line 1845 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 48:
#line 455 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_threshold = atoi(__cc_parser_yylval);
}
#line 1853 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 49:
#line 459 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_max_rate = atoi(__cc_parser_yylval);
}
#line 1861 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 50:
#line 463 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_ai_rate = atoi(__cc_parser_yylval);
}
#line 1869 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 51:
#line 467 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_hai_rate = atoi(__cc_parser_yylval);
}
#line 1877 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 52:
#line 471 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_gd = atoi(__cc_parser_yylval);
}
#line 1885 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 53:
#line 475 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_min_dec_fac = atoi(__cc_parser_yylval);
}
#line 1893 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 54:
#line 479 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rpg_min_rate = atoi(__cc_parser_yylval);
}
#line 1901 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 55:
#line 483 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rate_to_set_on_first_cnp = atoi(__cc_parser_yylval);
}
#line 1909 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 56:
#line 487 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.dce_tcp_g = atoi(__cc_parser_yylval);
}
#line 1917 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 57:
#line 491 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.dce_tcp_rtt = atoi(__cc_parser_yylval);
}
#line 1925 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 58:
#line 495 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.rate_reduce_monitor_period = atoi(__cc_parser_yylval);
}
#line 1933 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 59:
#line 499 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_rp_params.initial_alpha_value = atoi(__cc_parser_yylval);
}
#line 1941 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 60:
#line 503 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_np_params.min_time_between_cnps = atoi(__cc_parser_yylval);
}
#line 1949 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 61:
#line 507 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_np_params.cnp_sl_mode = atoi(__cc_parser_yylval);
}
#line 1957 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 62:
#line 511 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_conf->hca_np_params.cnp_sl = atoi(__cc_parser_yylval);
}
#line 1965 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 71:
#line 529 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	create_sw_conf();
}
#line 1973 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 72:
#line 533 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
}
#line 1980 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 73:
#line 536 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_sw_conf->group_type = osm_cc_get_group_type(__cc_parser_yylval);
}
#line 1988 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 74:
#line 540 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_sw_conf->enable = atoi(__cc_parser_yylval);
}
#line 1996 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 75:
#line 544 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_sw_conf->aqs_weight = atoi(__cc_parser_yylval);
}
#line 2004 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 76:
#line 548 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_sw_conf->aqs_time = atoi(__cc_parser_yylval);
}
#line 2012 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 84:
#line 566 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	free(p_current_profiles_conf);
	p_current_profiles_conf = create_profiles_conf();
	if (!p_current_profiles_conf)
		return 1;
}
#line 2023 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 85:
#line 573 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	cl_fmap_insert(&p_osm->sm.cc_mgr.cc_profiles_map,
		       &p_current_profiles_conf->name,
		       &p_current_profiles_conf->fmap_item);
	p_current_profiles_conf = NULL;
}
#line 2034 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 94:
#line 596 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	in_sl_config = TRUE;
	create_sl_conf();
}
#line 2043 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 95:
#line 601 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	in_sl_config = FALSE;
}
#line 2051 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 101:
#line 614 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_sl_conf->group_type = osm_cc_get_group_type(__cc_parser_yylval);
}
#line 2059 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 102:
#line 618 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	uint32_t elements_num = cl_list_count(&num_list);
	cl_list_iterator_t list_iterator;
	uint64_t *p_num;
	uint64_t num = 0;
	int i = 0;

	if ((elements_num != 1) && (elements_num != IB_NUMBER_OF_SLS)) {
		yyerror("Number of SLs(%u) is incorrect, supposed to be %u",
			elements_num, IB_NUMBER_OF_SLS);
		cl_list_remove_all(&num_list);
		return 1;
	}

	list_iterator = cl_list_head(&num_list);
	while (list_iterator != cl_list_end(&num_list)) {
		p_num = (uint64_t*)cl_list_obj(list_iterator);
		num = *p_num;
		free(p_num);
		if (num > OSM_CC_MAX_PROFILE_NUM) {
			yyerror("Wrong profile number %u, "
				"value should be between 1 to %u",
				num, OSM_CC_MAX_PROFILE_NUM);
			cl_list_remove_all(&num_list);
			return 1;
		}

		p_current_sl_conf->sl2profile_num[i++] = (uint8_t)num;
		list_iterator = cl_list_next(list_iterator);
	}

	if (elements_num == 1) {
		for (; i < IB_NUMBER_OF_SLS; i++)
			p_current_sl_conf->sl2profile_num[i] = (uint8_t)num;
	}

	cl_list_remove_all(&num_list);
}
#line 2102 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 104:
#line 660 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	create_vl_conf();
}
#line 2110 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 105:
#line 664 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
}
#line 2117 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 111:
#line 676 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	p_current_vl_conf->group_type = osm_cc_get_group_type(__cc_parser_yylval);
}
#line 2125 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 112:
#line 680 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	uint32_t elements_num = cl_list_count(&str_list);
	cl_list_iterator_t list_iterator;
	osm_cc_profiles_conf_t *p_profiles_conf = NULL;
	cl_fmap_item_t *p_item;
	char *tmp_str;
	int i = 0;

	if ((elements_num != 1) && (elements_num != IB_MAX_NUM_VLS)) {
		yyerror("Number of VLs(%u) is incorrect, supposed to be %u",
			elements_num, IB_MAX_NUM_VLS);
		cl_list_remove_all(&str_list);
		return 1;
	}

	list_iterator = cl_list_head(&str_list);
	while (list_iterator != cl_list_end(&str_list)) {
		tmp_str = (char *)cl_list_obj(list_iterator);
		p_item = cl_fmap_get(&p_osm->sm.cc_mgr.cc_profiles_map, tmp_str);

		if (p_item == cl_fmap_end(&p_osm->sm.cc_mgr.cc_profiles_map)) {
			yyerror("Profiles triplet with the name: %s is not defined", tmp_str);
			return 1;
		}

		p_profiles_conf = (osm_cc_profiles_conf_t *)p_item;
		p_current_vl_conf->vl_to_profiles[i++] = p_profiles_conf;
		list_iterator = cl_list_next(list_iterator);
	}

	if (!p_profiles_conf) {
		yyerror("invalid vl profiles configuration");
		return 1;
	}

	if (elements_num == 1) {
		for (; i < IB_MAX_NUM_VLS; i++)
			p_current_vl_conf->vl_to_profiles[i] = p_profiles_conf;
	}

	cl_list_remove_all(&str_list);
}
#line 2172 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 115:
#line 727 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	uint64_t *p_num = (uint64_t*)malloc(sizeof(uint64_t));
	if (!p_num) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 8E05: Couldn't allocate memory, Aborting parsing\n");
		return 1;
	}

	*p_num = strtoull(__cc_parser_yylval, NULL, 0);
	cl_list_insert_tail(&num_list, p_num);
}
#line 2188 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 118:
#line 743 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	char *tmp_str = strdup(__cc_parser_yylval);
	if (!tmp_str) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 8E05: Couldn't allocate memory for "
			"profile triplet name, Aborting parsing\n");
		return 1;
	}

	cl_list_insert_tail(&str_list, tmp_str);
}
#line 2204 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 119:
#line 755 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E05: Unexpected "
		"input |%.200s|, Aborting parsing!\n", __cc_parser_yylval);
	return 1;
}
#line 2214 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 120:
#line 761 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	clear_profile();
	in_profile = TRUE;
}
#line 2223 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 121:
#line 766 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	if (!p_current_profiles_conf)
		return 1;

	if (strlen(p_current_profiles_conf->name)) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E01: Profiles conf name "
			"qualifier already defined (%.200s), Aborting "
			"congestion control parsing!!!\n", __cc_parser_yylval);
		return 1;
	}

	snprintf(p_current_profiles_conf->name, sizeof(p_current_profiles_conf->name), "%s", __cc_parser_yylval);
}
#line 2241 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 122:
#line 780 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	if (!p_current_profiles_conf)
		return 1;

	if (p_current_profiles_conf->mode != NOT_DEFINED) {
		yyerror("Profiles conf mode tag already defined");
		return 1;
	}

	if (strlen(__cc_parser_yylval) <= CC_MAX_MODE_LEN) {
		p_current_profiles_conf->mode = atoi(__cc_parser_yylval);
	} else {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 8E07: Illegal "
			"mode, mode qualifier length must be up to "
			"%d, Aborting congestion control parsing!!!\n",
			CC_MAX_MODE_LEN);
		return 1;
	}
}
#line 2265 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 123:
#line 800 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	if (__cc_profile_is_tag_defined(profile_percent, "profile_percent"))
		return 1;

	profile_percent = strdup(__cc_parser_yylval);
}
#line 2276 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 124:
#line 807 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	if (__cc_profile_is_tag_defined(profile_min, "profile_min"))
		return 1;

	profile_min = strdup(__cc_parser_yylval);
}
#line 2287 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 125:
#line 814 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	if (__cc_profile_is_tag_defined(profile_max, "profile_max"))
		return 1;

	profile_max = strdup(__cc_parser_yylval);
}
#line 2298 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;

  case 126:
#line 821 "./osm_cc_parser_y.y" /* yacc.c:1646  */
    {
	in_profile = FALSE;
	if (!profile_max || !profile_min || !profile_percent) {
		clear_profile();
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 8E08: One of the profile tags is not defined"
			", Aborting congestion control parsing!!!\n");
		return 1;
	}

	create_profile();
	clear_profile();
}
#line 2316 "./osm_cc_parser_y.c" /* yacc.c:1646  */
    break;


#line 2320 "./osm_cc_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
