%{
/*
 * Copyright (c) 2013 Mellanox Technologies LTD. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#include <stdio.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_PORT_GRP_PARSER_L_L
#include "osm_port_grp_parser_y.h"
extern char *__pgrp_parser_yylval;
extern char *prev_word;
extern char *trim_whitespace(char *str);

%}


%option nounput noinput

%%

\#.*\n			      return COMMENT;
[ \t]*\n                      /* ignore end of line and empty lines*/;
[ \t]*port-group[ \t]*        return P_GRP_START;
[ \t]*end-port-group[ \t]*    return P_GRP_END;
[ \t]*use:                    return USE;
[ \t]*name:                   return NAME;
[ \t]*port-regexp:            return REGEX;
[ \t]*port-guid:              return GUID_LIST;
[ \t]*port-name:              return HOSTNAME;
[ \t]*port-guid-range:        return RANGE;
[ \t]*union-rule:             return UNION;
[ \t]*subtract-rule:          return SUBTRACT;
[a-zA-Z0-9'.''_'','' ''\t''\-''|''&''@''('')''/''#''!''?''+''=''[''\]''\/''{''}'';''%''*''^''\\']*                    {
			free(prev_word);
			prev_word = __pgrp_parser_yylval;
			__pgrp_parser_yylval=strdup(trim_whitespace(yytext));
			return WORD;
			}
%%
