%{
/*
 * Copyright (c) 2013 Mellanox Technologies LTD. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#include <stdio.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_RCH_PARSER_L_L
#include "osm_rch_parser_y.h"
extern char *__rch_parser_yylval;
extern char *prev_word;
extern char *trim(char *str);

%}


%option nounput noinput

%%

\#.*\n				return COMMENT;
[ \t]*unicast-step[ \t]*	return STEP_START;
[ \t]*end-unicast-step[ \t]*	return STEP_END;
[ \t]*topology:			return TOPOLOGY;
[ \t]*use:			return USE;
[ \t]*config:			return CONFIG;
[ \t]*engine:			return ENGINE;
[ \t]*path-bit:			return PATH_BIT;
[ \t]*fallback-to:		return FALL_BACK;
[ \t]*id:			return ID;
[a-zA-Z0-9'.''_'','' ''\t''\-''|''&''@''('')''/''#''!''?''+''=''[''\]''\/''{''}'';''%''*''^''\\']*                    {
			if (__rch_parser_yylval)
				free(__rch_parser_yylval);
			__rch_parser_yylval=strdup(trim(yytext));
			return WORD;
			}
[ \t]*\n                      /* ignore end of line and empty lines*/;
%%
